c
c Test program
c
c With the input
c
c     .000000     .000000    2.838056
c  140.160308  122.863257  129.935697
c    2.462498     .000000    1.407012
c  101.797546   33.564944  228.814460
c     .000000     .000000     .000000
c  319.261409  111.126505   18.816826
c
c the output should be:
c
c H2O 3B routines initialized.....
c Three-body energy: -2.00215633455107334
c
c
      subroutine en3Bdrive(comeuler,pot123)
      implicit real*8 (a-h,o-z)
      parameter (amu=1822.888479778837d0,angstrom=1.88972613392125d0)
      parameter (nmonomers=3)
      dimension comeuler(6,nmonomers)
      dimension cent(3,3),omega(3,3)
cwc1
      logical init
      save init
      data init /.false./
cwc0
c
      deg2rad = dacos(-1.d0)/180.d0
c
      do i=1,3                        ! loop over molecules
c      read(5,*)(cent(j,i),j=1,3)     ! COM coords in Angstroms
c                                     ! come in bohrs from comeuler,  covert
       do j=1,3
        cent(j,i) = comeuler(j,i)/angstrom
       enddo
c      read(5,*)(omega(j,i),j=1,3)    ! z-y-z Euler angles in degrees
c      angles in comeuler are in radians
       do j=1,3
         omega(j,i) = comeuler(3+j,i)
       enddo
      end do
c
c Convert Euler angles to radians  <== commented out if from comeuler
c
c     do i=1,3
c     do j=1,3
c      omega(i,j) = deg2rad*omega(i,j)
c     end do
c     end do
c
cwc1
      if (.not.init) then
cwc0
      imode = -1                      ! initialize routine
      call en3B(cent(1,1),omega(1,1),cent(1,2),omega(1,2),
     1          cent(1,3),omega(1,3),pot123,imode)
cwc1
      init=.true.
      end if
cwc0
      imode = 1                       ! calculation proper
      call en3B(cent(1,1),omega(1,1),cent(1,2),omega(1,2),
     1          cent(1,3),omega(1,3),pot123,imode)
c
c     write(6,*)'Three-body energy:',pot123   ! in kcal/mol
c
c     stop
      return
      end
c
c H2O 3-body energy routines. 
c
      subroutine en3B(ci,oi,cj,oj,ck,ok,pot123,imode)
      implicit real*8 (a-h,o-z)
      parameter (Nmax=3,nsmax=3)
      dimension ci(3),cj(3),ck(3),oi(3),oj(3),ok(3)
      dimension coor(4,10,3),vpom(3),tran(3,3)
      dimension sit(3,nsmax),am(nsmax)
      common/pfield/ pfld(3,Nmax,Nmax),pfstore(3,2,Nmax),iupdtpf
      data sit /0.d0, 0.d0, 0.065952378d0,             ! O
     1         -0.769239546d0, 0.d0, -0.527619003d0,   ! H1
     1          0.769239546d0, 0.d0, -0.527619003d0 /  ! H2
      data am /15.994915d0,1.007825d0,1.007825d0 /     ! Masses H2O
c     data am /15.994915d0,2.0140d0,  2.0140d0   /     ! Masses D2O
      save
c
      if(imode.eq.-1) then
c
c Initialize the routine if called with imode = -1.
c
       call setup_par(5)   ! ifit5 version
c      write(6,*) 'H2O 3B routines initialized.....'
       a2bohr = 1.d0/0.529177249d0
c
c Shift the coordinates to COM
c
       amtot = 0.d0
       do i=1,3
        amtot = amtot + am(i)
       end do
       do i=1,3
        tran(i,1) = 0.d0
        do j=1,3
         tran(i,1) = tran(i,1) + am(j)*sit(i,j)
        end do
        tran(i,1) = tran(i,1)/amtot
       end do
      do i=1,3
       do j=1,3
        sit(i,j) = sit(i,j) - tran(i,1)
       end do
      end do

      return
      endif
c
c Rotate and shift the monomers...  molecule 1 (i)
c
      call rotmat(oi(1),oi(2),oi(3),tran)
      do i=1,3
       do j=1,3
        vpom(j) = sit(j,i)
       end do
       call matvec(tran,vpom)
       do j=1,3
        coor(1,i,j) = a2bohr*(ci(j) + vpom(j))
       end do
      end do
c
c Rotate and shift the monomers...  molecule 2 (j)
c
      call rotmat(oj(1),oj(2),oj(3),tran)
      do i=1,3
       do j=1,3
        vpom(j) = sit(j,i)
       end do
       call matvec(tran,vpom)
       do j=1,3
        coor(2,i,j) = a2bohr*(cj(j) + vpom(j))
       end do
      end do
c
c Rotate and shift the monomers...  molecule 3 (k)
c
      call rotmat(ok(1),ok(2),ok(3),tran)
      do i=1,3
       do j=1,3
        vpom(j) = sit(j,i)
       end do
       call matvec(tran,vpom)
       do j=1,3
        coor(3,i,j) = a2bohr*(ck(j) + vpom(j))
       end do
      end do
c
c Create the additional centers on both molecules out of
c O and H coordinates
c
      call coorgen(4,coor(1,1,1),coor(1,1,2),coor(1,1,3),sig,sig2,
     1             sig3,sig4,sig5)
c
c Calculate the permanent electric field on each molecule
c pfld(*,i,j) is the field of molecule j on polarizable center of
c molecule i
c
      do i=1,3
      do j=1,3
c (separ ignored...)
       call field5s_1g(coor,i,j,separ,pfld(1,i,j))
      end do
      end do
c
c Finally, call the 3B procedure and exit
c
      call three(coor,pot123,1,2,3)
      return
      end
c
c Fit of the complete 3b SCF nonadditivity for H2O.
c Various versions of the site-site fits with induction up to
c alpha^2 and exchange-quadrupole S2 term. S3 and the
c remaining "spherical" terms simulated with an expansion
c in terms of exponents * P_l, as for Ar_3 trimer.
c
c setup_par(ifit) should be called in the beginning, with
c ifit denoting the version of the fit. Currently only
c ifit=1 ("withS2" fit) and ifit=2 ("withS2.total" fit) implemented.
c
c This is the attenuated version, i.e., the S3 term is smoothly
c switched off between 6.5 and 8 bohr (average triangle side) and 
c neglected completely after 8 bohr.
c
c      subroutine three_ss(coor,S2exch,S3exch,Eind2,Eind3,i0,j0,k0)
c Simplify the header to port to psim.512.f program.
      subroutine three(coor,energy,i0,j0,k0)
      implicit real*8 (a-h,o-z)
      character*8 label(9)
      PARAMETER (Npmax = 1,Nmax=3,Nbmax=15)
      parameter (maxb=6*Nbmax,maxp=Npmax,ntypemax=6)
      parameter (ntpm=ntypemax*(ntypemax+1)/2)
      dimension coor(4,10,3),a(maxb)
      dimension ddd(Nbmax,3),dstmat(3,3,3,3),p(0:2,3,3,3,3)
      dimension itypu(ntpm,ntpm)
      dimension itype(10),values(maxb),values1(maxb)
      dimension is1(6),is2(6),is3(6)
      common/pfield/ efld(3,Nmax,Nmax),pfstore(3,2,Nmax),iupdtpf
c The two following commons set up in setup_par routine...
      common/dat/ par(100),iopar(100),nparam
      common/linear/ c(maxb),ncoef,nlb(6,Nbmax),nbas,iuse(maxb)
c      common/times/ time1,time2,time3,time4,time5
c
      equivalence (par(45),ddd)
      equivalence (par(37),AOOexp),(par(38),AHHexp),(par(39),AOHexp),
     1            (par(40),betaOO),(par(41),betaHH),(par(42),betaOH)
      data itype /1,2,2,3,3,4,5,5,6,0/
      data is1 /1,3,2,1,2,3/
      data is2 /2,1,3,3,1,2/
      data is3 /3,2,1,2,3,1/
      save
c
c Get distances and Legendre polynomials:
c
      call getdsts(coor,dstmat,p)
c S3 Attenuation addition
      r_av = (dstmat(1,1,2,1)+dstmat(1,1,3,1)+dstmat(2,1,3,1))/3.d0
      S3exch = 0.d0
c end S3 Attenuation addition
c
c Zero out the used-type matrix 
c
         do k1=1,ntpm
         do k2=1,ntpm
          itypu(k1,k2) = 0
         end do
         end do
c
c Zero out the a(*) vector
c
        do i=1,maxb
         a(i) = 0.d0
        end do
c
c Compute the electric fields for the "classical part" of induction
c Remove later, will be computed elsewhere
c
c      do i=1,3
c      do j=1,3
c       call field5s_1g(coor(1,1,1),i,j,efld(1,i,j))
c      end do
c      end do
c
c Calculate the "nonlinear" parts of the energy
c
c i0,j0,k0 in ind3tot only to select the proper fields
c
      call ind3tot(coor(1,1,1),eind2,eind3,i0,j0,k0)
      call E10exS2_5s(coor(1,1,1),S2exch,AOOexp,AHHexp,AOHexp,
     1 betaOO, betaHH, betaOH)
c S3 Attenuation addition
      if(r_av.gt.8.d0) go to 222
c      if(r_av.gt.0.d0) go to 222
c end S3 Attenuation addition
c
c Start loop over sites...
c
      iii = 1
      do ia=1,3
      do ib=1,1   ! assuming only the O site on each B molecule
      do ic=1,3
c
c Extract the site types...
c
       ita = itype(ia)
       itb = itype(ib)
       itc = itype(ic)
       itmx = max(ita,itb)
       itmn = min(ita,itb)
       ita = (itmx-1)*itmx/2+itmn
       itmx = max(itb,itc)
       itmn = min(itb,itc)
       itb = (itmx-1)*itmx/2+itmn
       itmx = max(itype(ia),itc)
       itmn = min(itype(ia),itc)
       itc = (itmx-1)*itmx/2+itmn
c
c Loop over 6 monomer permutations (maybe shorten in the future)
c
        iper_b = 1
        iper_e = 6
        nbas_b = 1
        nbas_e = nbas
c       do iper=1,6
       do iper=iper_b,iper_e
c
c Substitute the precomputed distances between the sites
c
       rab = dstmat(is1(iper),ia,is2(iper),ib)
       rbc = dstmat(is2(iper),ib,is3(iper),ic)
       rac = dstmat(is1(iper),ia,is3(iper),ic)
c
c Which Legendre polynomials to provide
c
       call permut(iper,ia,ib,ic,iap,ibp,icp)
c
c Calculate the values of the basis functions at points np.
c
        call fun_bas(rab,rbc,rac,nlb,nbas_b,nbas_e,
     1  p(0,is2(iper),iap,ibp,icp),
     1  p(0,is1(iper),iap,ibp,icp),
     1  p(0,is3(iper),iap,ibp,icp),
     1  ddd(1,ita),ddd(1,itb),ddd(1,itc),values)
c
c decide which basis function it is (basis function is determined
c by the triplet of site types and the position in values vector).
c iii is the first basis function for this triplet of types. It is
c updated into the next available position for the next pair of types.
c
       itu = itypu(ita,itb)
       if(itu.eq.0) then
c         write(6,*)'Types:',itype(ia),itype(ib),itype(ic)
c         write(6,*)'Type pairs',ita,itb,itc
c         write(6,*)'Start of the basis functions:',iii
c Mark the type used....
        itypu(ita,itb) = iii
        itu = iii
        iii = iii + nbas
       endif
c
c Fill up the planning matrix...
c
       do i = nbas_b,nbas_e
        itu1 = itu+i-1
        a(itu1) = a(itu1) + values(i)
       end do
c
c End loop over monomer permutations...
c
       end do
c
c End loops over sites...
c
       end do
       end do
       end do
c
c Set the dimension of the a(*) matrix here
c
      nb = iii - 1
c
c Calculate the total 3B energies 
      term = a0
      iii = 0
      do j=1,nb
c skip the unwanted items base on matrix iuse
c iuse(i) = 1 means that the item i is active
       if(iuse(j).eq.1) then
        iii = iii + 1
        term = term + c(iii)*a(j)
       endif
      end do
c
c 3B energy ready, in "term"
c
      S3exch = term
c S3 Attenuation addition
      atten = 1.d0/(1.d0 + dexp(9.21d0*(r_av - 7.25d0)))
      S3exch = atten*S3exch
 222  continue     ! S3exch left as zero if jumped here...
c end S3 Attenuation addition
c The total 3B energy now... convert to K.
c      energy = 503.215885d0*(S2exch+S3exch+Eind2+Eind3)
      energy = S2exch+S3exch+Eind2+Eind3
c
      return
      end
c
c Calculate the contribution of molecule j to the field on i
c Use the corrected SAPT-5s charges (sapt5s_1). Variable
c separ is ignored (introduced only for compatibility
c with the simulation program).
c
      subroutine field5s_1g(coor,i,j,separ,e)
      implicit real*8 (a-h,o-z)
      dimension coor(4,10,3),e(3)
      dimension sep1(3),sep2(3),sep3(3),chrg(3)
      dimension sep4(3),sep5(3)
      common/dat/ par(100),iopar(100),nparam
      equivalence (par(1),sigpol),(par(2),damp30),(par(3),aex),
     1            (par(4),gamma),(par(5),r0),(par(6),dampSq)
      data plen /1.1216873242d0 /
c position of the polarizability along the bisector given by sigpol
      data chrg /0.258504607653328389d0,0.564050362569283648d0,
     1           -0.693302666395947953d0 /
c
      sep1l = 0.d0    !  O <- COM
      sep2l = 0.d0    ! H1 <- COM
      sep3l = 0.d0    ! H2 <- COM
      sep4l = 0.d0    ! B7 <- COM
      sep5l = 0.d0    ! B8 <- COM
      do k=1,3
       veci = coor(i,2,k) + coor(i,3,k) - 2.d0*coor(i,1,k)
       veci = coor(i,1,k) + 0.5d0*sigpol*veci/plen
c COM version
c       sep1(k) = coor(i,6,k) - coor(j,1,k)
c       sep2(k) = coor(i,6,k) - coor(j,2,k)
c       sep3(k) = coor(i,6,k) - coor(j,3,k)
c       sep4(k) = coor(i,6,k) - coor(j,7,k)
c       sep5(k) = coor(i,6,k) - coor(j,8,k)
c Moving polarizability version
       sep1(k) = veci - coor(j,1,k)
       sep2(k) = veci - coor(j,2,k)
       sep3(k) = veci - coor(j,3,k)
       sep4(k) = veci - coor(j,7,k)
       sep5(k) = veci - coor(j,8,k)
       sep1l = sep1l + sep1(k)*sep1(k)
       sep2l = sep2l + sep2(k)*sep2(k)
       sep3l = sep3l + sep3(k)*sep3(k)
       sep4l = sep4l + sep4(k)*sep4(k)
       sep5l = sep5l + sep5(k)*sep5(k)
      end do
      sep1l = sep1l**(-1.5d0)
      sep2l = sep2l**(-1.5d0)
      sep3l = sep3l**(-1.5d0)
      sep4l = sep4l**(-1.5d0)
      sep5l = sep5l**(-1.5d0)
      do k=1,3
       e(k) = chrg(1)*sep1(k)*sep1l +
     1        chrg(2)*(sep2(k)*sep2l + sep3(k)*sep3l) +
     1        chrg(3)*(sep4(k)*sep4l + sep5(k)*sep5l)
      end do
c
      return
      end
c
c ########### three-body programs.... #######
c
      subroutine ind3tot(coor,energy2,energy,i0,j0,k0)
      implicit real*8 (a-h,o-z)
      PARAMETER (Nmax=3 )
      dimension coor(4,10,3),OO(3),im(3)
      dimension enpom(6),idist(3,6),mapdst(3,3)
      dimension enpom2(18),idist2(3,18),ipow2(3,18)
      dimension pom1(3),pom2(3),Ri(3),Rj(3),ipow(3,6)
      common/pfield/ efld(3,Nmax,Nmax),pfstore(3,2,Nmax),iupdtpf
      common/dat/ par(100),iopar(100),nparam
      equivalence (par(1),sigpol),(par(2),damp30),(par(3),aex),
     1            (par(4),gamma),(par(5),r0),(par(6),dampSq)
c diplen is the SCF dipole moment
      data plen / 1.1216873242d0/, diplen /.7891759d+00/
      data pol  / 10.31387108d00/
      save
c Set the fit parameters: -- supplied from the outside through common/dat/
c       damp30 =  2.97279605176084294d0
c       dampSq = 2.30717868651008118d0
c       aex    = 0.625295591225065062d0
c       gamma  = 13.0502148565292284d0
c       r0     = 5.28613269520695894d0
c parameters from optblow_1.2 with chisq = 60.278445
c (optmimization interrupted when aex reached 1.
c       damp30 = 1.21344537130961294d0
c       dampSq = 0.955929424377419568d0
c       aex    =  1.06689982396137983d0
c       gamma  = 0.199989601568964087d-01
c       r0     =  5.20000000000000018d0
c parameters from optblow.5s_1 with chisq = 35.9727
c (optmimization interrupted after first cycle
c       damp30 = 0.946434340410350905d0
c       dampSq = 0.944499213666449400d0
c       aex    = 1.26668459274490153d0
c       gamma  = 0.03d0
c       r0     = 1.d0     ! irrelevant, not used
c parameters from optblow.5s_1 with chisq = 18.78922
c (optmimization interrupted after three cycles
c       damp30 = 0.943682691449228450d0
c       dampSq = 1.08715694978386201d0
c       aex    = 1.20347408390928079d0
c       gamma  = 0.299999999999999989d-01
c       r0    =  1.00000000000000000d0      ! irrelevant, not used
C
      halfdipplen = 0.5d0*diplen/plen
c Label the distances
      mapdst(1,2) = 1
      mapdst(2,1) = mapdst(1,2)
      mapdst(1,3) = 2
      mapdst(3,1) = mapdst(1,3)
      mapdst(2,3) = 3
      mapdst(3,2) = mapdst(2,3)
c Set pointers to molecules to pick out the electric field
      im(1) = i0
      im(2) = j0
      im(3) = k0
c Calculate the COM distances
c       OO(1) = dsqrt(   (coor(1,6,1)-coor(2,6,1))**2.d0
c     &                 +(coor(1,6,2)-coor(2,6,2))**2.d0
c     &                 +(coor(1,6,3)-coor(2,6,3))**2.d0 )
c
c       OO(2) = dsqrt(   (coor(1,6,1)-coor(3,6,1))**2.d0
c     &                 +(coor(1,6,2)-coor(3,6,2))**2.d0
c     &                 +(coor(1,6,3)-coor(3,6,3))**2.d0 )
c
c       OO(3) = dsqrt(   (coor(2,6,1)-coor(3,6,1))**2.d0
c     &                 +(coor(2,6,2)-coor(3,6,2))**2.d0
c     &                 +(coor(2,6,3)-coor(3,6,3))**2.d0 )
c
c Calculate distances between polarizable centers...
       OO(1) = 0.d0
       do k=1,3
        vec1 = coor(1,2,k)+coor(1,3,k)-2.d0*coor(1,1,k) 
        vec1 = coor(1,1,k) + 0.5d0*sigpol*vec1/plen
        vec2 = coor(2,2,k)+coor(2,3,k)-2.d0*coor(2,1,k)
        vec2 = coor(2,1,k) + 0.5d0*sigpol*vec2/plen
        OO(1) = OO(1) + (vec1-vec2)*(vec1-vec2)
       end do
       OO(1) = dsqrt(OO(1))
       OO(2) = 0.d0
       do k=1,3
        vec1 = coor(1,2,k)+coor(1,3,k)-2.d0*coor(1,1,k)
        vec1 = coor(1,1,k) + 0.5d0*sigpol*vec1/plen
        vec2 = coor(3,2,k)+coor(3,3,k)-2.d0*coor(3,1,k)
        vec2 = coor(3,1,k) + 0.5d0*sigpol*vec2/plen
        OO(2) = OO(2) + (vec1-vec2)*(vec1-vec2)
       end do
       OO(2) = dsqrt(OO(2))
       OO(3) = 0.d0
       do k=1,3
        vec1 = coor(2,2,k)+coor(2,3,k)-2.d0*coor(2,1,k)
        vec1 = coor(2,1,k) + 0.5d0*sigpol*vec1/plen
        vec2 = coor(3,2,k)+coor(3,3,k)-2.d0*coor(3,1,k)
        vec2 = coor(3,1,k) + 0.5d0*sigpol*vec2/plen
        OO(3) = OO(3) + (vec1-vec2)*(vec1-vec2)
       end do
       OO(3) = dsqrt(OO(3))
cccccccccccccccc Calculate everything ccccccccccccccccc
c Only the alpha terms for now. Requires a triple loop with
c 6 elements. Can be shortened to 3 in the future...
        kk = 0
       do i=1,3
       do j=1,3
       do k=1,3
       if(i.eq.j) go to 11
       if(i.eq.k) go to 11
       if(j.eq.k) go to 11   ! not a three-body 
        kk = kk + 1
c Assume a simple charge representation of the dipole
c i.e., a 0.351780698 charge on H's and -2*q on COM
c         call field(coor,i,j,oo(mapdst(i,j)),pom1)
c         call field(coor,i,k,oo(mapdst(i,k)),pom2)
c         enpom(kk) = -0.5d0*pol*scalp(pom1,pom2)
c Use the previously computed fields
c Use a general version of scalar product
         enpom(kk) = -0.5d0*pol*scalp(efld(1,im(i),im(j)),
     1                                efld(1,im(i),im(k)),3)
cccccccccccccccccccccccccccccccccccccccccccccccccccccc
         idist(1,kk) = mapdst(i,j)
         idist(2,kk) = mapdst(i,k)
         idist(3,kk) = 0
c assign the appropriate powers to distances for damping
         ipow(1,kk) = 0
         ipow(2,kk) = 0
         ipow(3,kk) = 0
         ipow(mapdst(i,j),kk) = ipow(mapdst(i,j),kk) + 3
         ipow(mapdst(i,k),kk) = ipow(mapdst(i,k),kk) + 3
 11    continue
       end do
       end do
       end do
c
c Alpha square terms. Requires a quadruple loop with 18
c elements. Can be shortened twice in the future...
c
c        go to 13
        kk = 0
        do i=1,3
        do j=1,3
        do k=1,3
        do l=1,3
         if(i.eq.k) go to 12
         if(i.eq.j) go to 12
         if(j.eq.l) go to 12
         if(k.eq.j.and.l.eq.i) go to 12
          kk = kk +1
         idist2(1,kk) = mapdst(i,k)
         idist2(2,kk) = mapdst(i,j)
         idist2(3,kk) = mapdst(j,l)
c assign the appropriate powers to distances for damping
         ipow2(1,kk) = 0
         ipow2(2,kk) = 0
         ipow2(3,kk) = 0
         ipow2(mapdst(i,k),kk) = ipow2(mapdst(i,k),kk) + 3
         ipow2(mapdst(i,j),kk) = ipow2(mapdst(i,j),kk) + 3
         ipow2(mapdst(j,l),kk) = ipow2(mapdst(j,l),kk) + 3
c Evaluate energy:
ccccccc the charge-dipole model comes here
         dst1G1 = OO(mapdst(i,j))**(-3)
         do m=1,3
c          Ri(m) = coor(i,6,m)
c          Rj(m) = coor(j,6,m)
          Ri(m) = coor(i,2,m)+coor(i,3,m)-2.d0*coor(i,1,m)
          Ri(m) = coor(i,1,m) + 0.5d0*Ri(m)*sigpol/plen
          Rj(m) = coor(j,2,m)+coor(j,3,m)-2.d0*coor(j,1,m)
          Rj(m) = coor(j,1,m) + 0.5d0*Rj(m)*sigpol/plen
         end do
         call TprodA(Ri,Rj,efld(1,im(j),im(l)),dst1G1,pom2)
c         call Tprod1A(coor,i,j,efld(1,j,l),dst1G1,pom2)
c         enpom2(kk) = -0.5d0*pol*pol*scalp(pom1,pom2)
c Use a general version of scalar product
         enpom2(kk) = -0.5d0*pol*pol*scalp(efld(1,im(i),im(k)),pom2,3)
cccccccc end of the charge dipole model
 12     continue
        end do
        end do
        end do
        end do
 13    continue
ccccccccccccccccc END of Calculate everything ccccccccc
      term = 0.d0
cccccccccccccc sum up now ccccccccccccccccccccccccccccc
c      
c Add the damped second-order induction here
      do kk=1,6
        nd1 = ipow(1,kk)
        nd2 = ipow(2,kk)
        nd3 = ipow(3,kk)
        dst1 = OO(1)
        dst2 = OO(2)
        dst3 = OO(3)
       dmpfct = 1.d0
       if(nd1.ne.0) dmpfct=dmpfct*d(nd1,damp30,dst1)
c     1                    *blowf(aex,gamma,r0,dst1)
       if(nd2.ne.0) dmpfct=dmpfct*d(nd2,damp30,dst2)
c     1                    *blowf(aex,gamma,r0,dst2)
       if(nd3.ne.0) dmpfct=dmpfct*d(nd3,damp30,dst3)
c     1                    *blowf(aex,gamma,r0,dst3)
c Temporarily turn off the (anti)damping
c       dmpfct = 1.d0

       term = term + dmpfct*enpom(kk)
      
      end do
      term2 = term
c Add the damped third-order induction here
c      go to 113
      do kk=1,18
        nd1 = ipow2(1,kk)
        nd2 = ipow2(2,kk)
        nd3 = ipow2(3,kk)
        dst1 = OO(1)
        dst2 = OO(2)
        dst3 = OO(3)
       dmpfct = 1.d0
c       if(nd1.ne.0) dmpfct=blowf(aex,gamma,r0,dst1)*dmpfct
c     1                    *d(nd1,dampSq,dst1)
c       if(nd2.ne.0) dmpfct=blowf(aex,gamma,r0,dst2)*dmpfct
c     1                    *d(nd2,dampSq,dst2)
c       if(nd3.ne.0) dmpfct=blowf(aex,gamma,r0,dst3)*dmpfct
c     1                    *d(nd3,dampSq,dst3)
c
       if(nd1.ne.0) dmpfct=dmpfct*d(nd1,damp30,dst1)
c     1                    *blowf(aex,gamma,r0,dst1)
       if(nd2.ne.0) dmpfct=dmpfct*d(nd2,damp30,dst2)
c     1                    *blowf(aex,gamma,r0,dst2)
       if(nd3.ne.0) dmpfct=dmpfct*d(nd3,damp30,dst3)
c     1                    *blowf(aex,gamma,r0,dst3)

       term = term + dmpfct*enpom2(kk)

      end do
 113  continue
c
      energy2 = 627.510d0*term2
      energy = 627.510d0*term-energy2
c

1011  format(6(F5.1,1x),2(F9.6,1x))
      end
c
      subroutine setup_par(ifit)
c
c Set up the parameters for the fit type given by ifit
c
c par(*) - parameter correspondence...
c
c      par(2) = damp30,  take dabs()
c      par(3) = aex,
c      par(4) = gamma,  take dabs()
c      par(5) = r0,   take dabs()
c      par(6) = dampSq, take dabs()
c      par(1) = sigpol
c      par(7) - par(16) = matrix b(1:10)      |
c      par(17) - par(26) = matrix Boo(1:10)   | <-- needed in E3
c      par(27) - par(36) = matrix Bhh(1:10)   |
c      par(37) = AOOexp   |
c      par(38) = AHHexp   |
c      par(39) = AOHexp   | <-- needed in E10exS2
c      par(40) = betaOO   |
c      par(41) = betaHH   |
c      par(42) = betaOH   |
c      par(43) = exqpos (position of exch-quad charge in E10(S2))
c      par(44) = O2Hscale | ratio of H to O exponents in the E3 term
cc      par(45) = OP-OP damping
cc      par(46) = HP-OP damping
cc      par(47) = OP-OP damping  ! old asymptotics damping...
cc      par(48) = HP-HP damping   
cc      par(45) = beta_11
cc      par(46) = beta_21         ! simple exponential ansatz
cc      par(47) = beta_22
c      par(45)-par(90) - exponents (column along basis, row along types)
c
      implicit real*8 (a-h,o-z)
      PARAMETER (Npmax = 1,Nbmax=15)
      parameter (maxb=6*Nbmax,maxp=Npmax,ntypemax=6)
      common/dat/ par(100),iopar(100),nparam ! collect all parameters here...
      common/linear/ coef(maxb),ncoef,nlb(6,Nbmax),nbas,iuse(maxb)
c
c Parameters for ifit = 1 (param.withS2):
c
      if(ifit.eq.1) then
c
c basis set data 
       nbas = 10
       do i=1,nbas
        do j=1,3
         nlb(j,i) = 0   ! set all powers of r to zero
        end do
       end do
       nlb(4,1) = 0  
       nlb(5,1) = 0  
       nlb(6,1) = 0
c
       nlb(4,2) = 1
       nlb(5,2) = 0
       nlb(6,2) = 0
c
       nlb(4,3) = 1
       nlb(5,3) = 1
       nlb(6,3) = 0
c
       nlb(4,4) = 2
       nlb(5,4) = 0
       nlb(6,4) = 0
c
       nlb(4,5) = 2
       nlb(5,5) = 1
       nlb(6,5) = 0
c
       nlb(4,6) = 2
       nlb(5,6) = 2
       nlb(6,6) = 0
c
       nlb(4,7) = 1
       nlb(5,7) = 1
       nlb(6,7) = 1
c
       nlb(4,8) = 2
       nlb(5,8) = 1
       nlb(6,8) = 1
c
       nlb(4,9) = 2
       nlb(5,9) = 2
       nlb(6,9) = 1
c
       nlb(4,10) = 2
       nlb(5,10) = 2
       nlb(6,10) = 2
c
c Iuse data - which one of the basis functions
c as given by the canonical sequence (see three_ss)
c to keep (iuse=1) or skip (iuse=0)
c
       do i=1,40
        iuse(i) = 1
       end do
       iuse(21) = 0
       iuse(22) = 0
       iuse(24) = 0
       iuse(27) = 0
       iuse(28) = 0
       iuse(30) = 0
c
c linear coefficients data 
c
       ncoef = 34
        coef( 1) = -0.3477779762D+07
        coef( 2) =  0.9687359380D+07
        coef( 3) = -0.4604774743D+07
        coef( 4) =  0.7267576003D+08
        coef( 5) = -0.2632189541D+07
        coef( 6) =  0.7011356554D+06
        coef( 7) =  0.7126712224D+08
        coef( 8) =  0.6327189648D+07
        coef( 9) = -0.1662970477D+07
        coef(10) =  0.1338808591D+06
        coef(11) =  0.1660347243D+06
        coef(12) = -0.4114041281D+06
        coef(13) =  0.2704782376D+06
        coef(14) =  0.9246645728D+05
        coef(15) = -0.2407005270D+06
        coef(16) =  0.4831011832D+05
        coef(17) =  0.2746401879D+06
        coef(18) = -0.1984489368D+06
        coef(19) = -0.2709871134D+05
        coef(20) =  0.8085927093D+05
        coef(21) = -0.2660050022D+06
        coef(22) =  0.1223143895D+06
        coef(23) =  0.8499967923D+05
        coef(24) = -0.1976576451D+06
        coef(25) =  0.2133977112D+04
        coef(26) = -0.9078466472D+04
        coef(27) =  0.1530703013D+05
        coef(28) =  0.8093997213D+04
        coef(29) = -0.1340347975D+05
        coef(30) =  0.4721408589D+04
        coef(31) = -0.2876686440D+04
        coef(32) =  0.8740427421D+04
        coef(33) = -0.8073185645D+04
        coef(34) =  0.3962536340D+04
c
c nonlinear parameters
c (only those from EQUIVALENCE statements are useful in practice,
c the rest comes from the previous fits, especially to E3)
c
        nparam = 89
        par(1) =   0.367911875040999981d0             
        par(2) =   2.394334557082217d0  
        par(3) =    1.20347408390928079d0             
        par(4) =   0.299999999999999989D-01           
        par(5) =    1.00000000000000000d0             
        par(6) =    1.08715694978386201d0             
        par(7) =   -47909236.4512617141d0             
        par(8) =    28607039.7051238120d0             
        par(9) =    12558728.0435810927d0             
        par(10) =    6282255.92169188615d0             
        par(11) =    329466.621355585929d0             
        par(12) =    130639.488489312906d0             
        par(13) =    123.647622808153315d0             
        par(14) =   -151.568453273019315d0             
        par(15) =   -410.581367324416476d0             
        par(16) =   -75.8689917755639271d0             
        par(17) =   0.692599844971184986d0             
        par(18) =   0.692599844971184986d0             
        par(19) =   0.692599844971184986d0             
        par(20) =   0.692599844971184986d0             
        par(21) =   0.692599844971184986d0             
        par(22) =   0.692599844971184986d0            
        par(23) =   0.692599844971184986d0             
        par(24) =   0.692599844971184986d0             
        par(25) =   0.692599844971184986d0             
        par(26) =   0.692599844971184986d0             
        par(27) =   0.488877655105790176d0             
        par(28) =   0.488877655105790176d0             
        par(29) =   0.488877655105790176d0             
        par(30) =   0.488877655105790176d0             
        par(31) =   0.488877655105790176d0             
        par(32) =   0.488877655105790176d0             
        par(33) =   0.488877655105790176d0             
        par(34) =   0.488877655105790176d0             
        par(35) =   0.488877655105790176d0             
        par(36) =   0.488877655105790176d0             
        par(37) =   0.693231401521010926d0             
        par(38) =   0.693231401521010926d0             
        par(39) =   0.693231401521010926d0             
        par(40) =   0.429183032897225480d0             
        par(41) =   0.429183032897225480d0             
        par(42) =   0.429183032897225480d0             
        par(43) =   0.400000000000000022d0             
        par(44) =   1.0d0                              
        par(45) =    0.5139444584718821d0 
        par(46) =    0.5156078929087301d0                        
        par(47) =    0.5187101470855933d0                        
        par(48) =    0.5047940180712186d0                        
        par(49) =    0.5108088229677370d0                       
        par(50) =    0.5079752747874443d0                        
        par(51) =    0.5045723376606069d0                        
        par(52) =    0.5210343561793994d0                        
        par(53) =    0.5109124005103034d0                        
        par(54) =    0.4929136709007139d0                        
        par(55) =   0.5d0   
        par(56) =   0.5d0   
        par(57) =   0.5d0   
        par(58) =   0.5d0   
        par(59) =   0.5d0   
        par(60) =    0.4879474988605208d0                        
        par(61) =    0.4921636623701032d0                        
        par(62) =    0.5010430137082842d0                        
        par(63) =    0.4884052069908422d0                        
        par(64) =    0.5201390680349998d0                        
        par(65) =    0.5128437215819589d0                        
        par(66) =    0.5064789365823866d0                        
        par(67) =    0.5061121322684150d0                        
        par(68) =    0.5457795335088858d0                        
        par(69) =    0.5951208160470604d0                        
        par(70) =   0.5d0  
        par(71) =   0.5d0   
        par(72) =   0.5d0   
        par(73) =   0.5d0   
        par(74) =   0.5d0   
        par(75) =    0.5417538309695832d0                        
        par(76) =    0.4494574085655629d0                        
        par(77) =    0.4247607889635260d0                        
        par(78) =    0.4534466713834436d0                        
        par(79) =    0.3685532093165481d0                        
        par(80) =    0.3826264621595382d0                        
        par(81) =    0.3631009424710991d0                        
        par(82) =    0.3693223989469658d0                        
        par(83) =    0.3841896823550978d0                        
        par(84) =    0.5332856897970932d0                        
        par(85) =   0.5d0   
        par(86) =   0.5d0   
        par(87) =   0.5d0   
        par(88) =   0.5d0   
        par(89) =   0.5d0   
c
      endif
c
c Parameters for ifit = 2 (param.withS2.total):
c
      if(ifit.eq.2) then
c
c basis set data 
       nbas = 10
       do i=1,nbas
        do j=1,3
         nlb(j,i) = 0   ! set all powers of r to zero
        end do
       end do
       nlb(4,1) = 0  
       nlb(5,1) = 0  
       nlb(6,1) = 0
c
       nlb(4,2) = 1
       nlb(5,2) = 0
       nlb(6,2) = 0
c
       nlb(4,3) = 1
       nlb(5,3) = 1
       nlb(6,3) = 0
c
       nlb(4,4) = 2
       nlb(5,4) = 0
       nlb(6,4) = 0
c
       nlb(4,5) = 2
       nlb(5,5) = 1
       nlb(6,5) = 0
c
       nlb(4,6) = 2
       nlb(5,6) = 2
       nlb(6,6) = 0
c
       nlb(4,7) = 1
       nlb(5,7) = 1
       nlb(6,7) = 1
c
       nlb(4,8) = 2
       nlb(5,8) = 1
       nlb(6,8) = 1
c
       nlb(4,9) = 2
       nlb(5,9) = 2
       nlb(6,9) = 1
c
       nlb(4,10) = 2
       nlb(5,10) = 2
       nlb(6,10) = 2
c
c Iuse data - which one of the basis functions
c as given by the canonical sequence (see three_ss)
c to keep (iuse=1) or skip (iuse=0)
c
       do i=1,40
        iuse(i) = 1
       end do
       iuse(21) = 0
       iuse(22) = 0
       iuse(24) = 0
       iuse(27) = 0
       iuse(28) = 0
       iuse(30) = 0
c
c linear coefficients data 
c
       ncoef = 34
        coef(  1) =   0.1782482086D+05 
        coef(  2) =  -0.1965626978D+05 
        coef(  3) =   0.2175930989D+03 
        coef(  4) =   0.7608920033D+03 
        coef(  5) =   0.2273318493D+06 
        coef(  6) =   0.1076502080D+10 
        coef(  7) =   0.5033775222D+05 
        coef(  8) =   0.5124954804D+06 
        coef(  9) =  -0.7333311662D+07 
        coef( 10) =   0.1496736850D+09 
        coef( 11) =  -0.1255651627D+06 
        coef( 12) =   0.3724096040D+06 
        coef( 13) =  -0.1913513630D+06 
        coef( 14) =  -0.2341820460D+06 
        coef( 15) =  -0.5527455942D+04 
        coef( 16) =  -0.2226568042D+08 
        coef( 17) =  -0.2152034213D+06 
        coef( 18) =   0.2905006588D+06 
        coef( 19) =  -0.2091056460D+06 
        coef( 20) =  -0.6306913734D+07 
        coef( 21) =  -0.7627993286D+05 
        coef( 22) =  -0.3143642254D+05 
        coef( 23) =  -0.1008027403D+08 
        coef( 24) =  -0.2693403228D+06 
        coef( 25) =   0.3029441340D+04 
        coef( 26) =  -0.2744670354D+04 
        coef( 27) =   0.5513435423D+04 
        coef( 28) =   0.3711135654D+05 
        coef( 29) =  -0.9720899903D+03 
        coef( 30) =   0.1275578335D+05 
        coef( 31) =  -0.2004922485D+04 
        coef( 32) =   0.2039785371D+03 
        coef( 33) =   0.6991909391D+06 
        coef( 34) =  -0.2187562321D+04 
c
c nonlinear parameters
c (only those from EQUIVALENCE statements are useful in practice,
c the rest comes from the previous fits, especially to E3)
c
        nparam = 89
        par(1) =   0.367911875040999981d0             
        par(2) =   1.919154158847074d0
        par(3) =    1.20347408390928079d0             
        par(4) =   0.299999999999999989D-01           
        par(5) =    1.00000000000000000d0             
        par(6) =    1.08715694978386201d0             
        par(7) =   -47909236.4512617141d0             
        par(8) =    28607039.7051238120d0             
        par(9) =    12558728.0435810927d0             
        par(10) =    6282255.92169188615d0             
        par(11) =    329466.621355585929d0             
        par(12) =    130639.488489312906d0             
        par(13) =    123.647622808153315d0             
        par(14) =   -151.568453273019315d0             
        par(15) =   -410.581367324416476d0             
        par(16) =   -75.8689917755639271d0             
        par(17) =   0.692599844971184986d0             
        par(18) =   0.692599844971184986d0             
        par(19) =   0.692599844971184986d0             
        par(20) =   0.692599844971184986d0             
        par(21) =   0.692599844971184986d0               
        par(22) =   0.692599844971184986d0               
        par(23) =   0.692599844971184986d0               
        par(24) =   0.692599844971184986d0               
        par(25) =   0.692599844971184986d0               
        par(26) =   0.692599844971184986d0               
        par(27) =   0.488877655105790176d0               
        par(28) =   0.488877655105790176d0               
        par(29) =   0.488877655105790176d0               
        par(30) =   0.488877655105790176d0               
        par(31) =   0.488877655105790176d0               
        par(32) =   0.488877655105790176d0               
        par(33) =   0.488877655105790176d0               
        par(34) =   0.488877655105790176d0               
        par(35) =   0.488877655105790176d0               
        par(36) =   0.488877655105790176d0               
        par(37) =   0.693231401521010926d0               
        par(38) =   0.693231401521010926d0               
        par(39) =   0.693231401521010926d0               
        par(40) =   0.429183032897225480d0               
        par(41) =   0.429183032897225480d0               
        par(42) =   0.429183032897225480d0               
        par(43) =   0.400000000000000022d0               
        par(44) =   1.0d0                                
        par(45) =    0.5256494238497388d0                        
        par(46) =    0.4906806709886168d0                       
        par(47) =    0.3280740908290500d0                        
        par(48) =    0.3936196480386553d0                        
        par(49) =    0.6064168383004646d0                        
        par(50) =     1.208233014222515d0                        
        par(51) =    0.5602134908468016d0                        
        par(52) =    0.7300366349682935d0                        
        par(53) =    0.8037806382943267d0                        
        par(54) =     1.026104153258931d0                        
        par(55) =   0.5d0   
        par(56) =   0.5d0   
        par(57) =   0.5d0   
        par(58) =   0.5d0   
        par(59) =   0.5d0   
        par(60) =    0.6411907223571165d0                        
        par(61) =    0.6595074308306527d0                        
        par(62) =    0.7850131923931738d0                        
        par(63) =    0.7331959000229240d0                        
        par(64) =    0.4880188243608535d0                        
        par(65) =     1.156062129268922d0                        
        par(66) =    0.5861010099898247d0                        
        par(67) =    0.5805848406864209d0                        
        par(68) =    0.7366211980454836d0                        
        par(69) =     1.093726858702323d0                        
        par(70) =   0.5d0   
        par(71) =   0.5d0   
        par(72) =   0.5d0   
        par(73) =   0.5d0   
        par(74) =   0.5d0   
        par(75) =    0.7109566345816291d0                        
        par(76) =    0.3814448741700884d0                        
        par(77) =    0.2760152707868684d0                        
        par(78) =     1.195516477160389d0                        
        par(79) =    0.8484078246642632d0                        
        par(80) =    0.6873253826553489d0                        
        par(81) =    0.7558079216089431d0                       
        par(82) =    0.1905388011557655d0                        
        par(83) =     1.670466666821842d0                        
        par(84) =    2.0017125654009714D-03                    
        par(85) =   0.5d0   
        par(86) =   0.5d0   
        par(87) =   0.5d0  
        par(88) =   0.5d0   
        par(89) =   0.5d0   
       endif
       if(ifit.eq.3) then
c optTotnd_598.1
        par(1) =   0.367911875040999981d0
c        par(2) =   1.919154158847074d0  ! correct coefficient
        par(2) = 3.295708730081901d0     ! coefficient used in the 3B fit.
        par(3) =    1.20347408390928079d0
        par(4) =   0.299999999999999989D-01
        par(5) =    1.00000000000000000d0
        par(6) =    1.08715694978386201d0
        par(7) = 1.73962793d0
        par(8) = 0.211371883d0
        par(9) = 1.07778251d0
        par(10) = -0.00222965198d0
        par(11) = -0.241042003d0
        par(12) = 0.611216584d0
        par(13) = 2.33708437d0
        par(14) = 0.462270373d0
        par(15) = 0.348776156d0
c        par(16) = 0.1983835105d+09
c        par(17) = -0.3210708076d+09
        par(16) = 0.1983835043d+09
        par(17) = -0.3210708024d+09
c        call par2Gauss(0)   ! set sigmas and exponents...
       endif
       if(ifit.eq.4) then
c optTotnd_ptot1.oldind
        par(1) =   0.367911875040999981d0
c        par(2) =   1.919154158847074d0  ! correct coefficient
        par(2) = 3.295708730081901d0     ! coefficient used in the 3B fit.
        par(3) =    1.20347408390928079d0
        par(4) =   0.299999999999999989D-01
        par(5) =    1.00000000000000000d0
        par(6) =    1.08715694978386201d0
        par(7) = 1.761799330176562d0
        par(8) = 0.2569302208573717d0
        par(9) = 1.110443488338000d0
        par(10) = -6.5192021234811333d-04
        par(11) = -0.2668435675768777d0
        par(12) = 0.3311194597150958d0
        par(13) = 2.549452022197594d0
        par(14) = 0.2704071635749332d0
        par(15) = 0.2212111726335716d0
        par(16) = 0.1369832961d+10
        par(17) = -0.1332112448d+11
c        call par2Gauss(0)   ! set sigmas and exponents...
       endif
       if(ifit.eq.5) then
c Ar-type exponential form, fitted to points.total.1 (7533 points)
c basis set data 
       nbas = 10
       do i=1,nbas
        do j=1,3
         nlb(j,i) = 0   ! set all powers of r to zero
        end do
       end do
       nlb(4,1) = 0  
       nlb(5,1) = 0  
       nlb(6,1) = 0
c
       nlb(4,2) = 1
       nlb(5,2) = 0
       nlb(6,2) = 0
c
       nlb(4,3) = 1
       nlb(5,3) = 1
       nlb(6,3) = 0
c
       nlb(4,4) = 2
       nlb(5,4) = 0
       nlb(6,4) = 0
c
       nlb(4,5) = 2
       nlb(5,5) = 1
       nlb(6,5) = 0
c
       nlb(4,6) = 2
       nlb(5,6) = 2
       nlb(6,6) = 0
c
       nlb(4,7) = 1
       nlb(5,7) = 1
       nlb(6,7) = 1
c
       nlb(4,8) = 2
       nlb(5,8) = 1
       nlb(6,8) = 1
c
       nlb(4,9) = 2
       nlb(5,9) = 2
       nlb(6,9) = 1
c
       nlb(4,10) = 2
       nlb(5,10) = 2
       nlb(6,10) = 2
c
c Iuse data - which one of the basis functions
c as given by the canonical sequence (see three_ss)
c to keep (iuse=1) or skip (iuse=0)
c
       do i=1,40
        iuse(i) = 1
       end do
       iuse(21) = 0
       iuse(22) = 0
       iuse(24) = 0
       iuse(27) = 0
       iuse(28) = 0
       iuse(30) = 0
c
c linear coefficients data
c
       ncoef = 34
      coef(  1) =  -0.2901962589E+06
      coef(  2) =   0.7709243563E+06
      coef(  3) =  -0.4789517565E+06
      coef(  4) =   0.4406875636E+06
      coef(  5) =  -0.1445210621E+07
      coef(  6) =   0.5233133514E+07
      coef(  7) =  -0.8676569928E+04
      coef(  8) =   0.9369774568E+06
      coef(  9) =  -0.3460515181E+06
      coef( 10) =   0.5667766521E+06
      coef( 11) =  -0.2327121180E+05
      coef( 12) =   0.1591574277E+05
      coef( 13) =   0.1978916906E+05
      coef( 14) =  -0.1532706130E+03
      coef( 15) =  -0.3445948376E+04
      coef( 16) =  -0.3780719627E+07
      coef( 17) =  -0.3191709784E+05
      coef( 18) =   0.5240105046E+04
      coef( 19) =   0.2914427460E+06
      coef( 20) =  -0.1720013450E+07
      coef( 21) =   0.7113296601E+05
      coef( 22) =   0.8622586429E+03
      coef( 23) =  -0.3728643595E+07
      coef( 24) =   0.4719504364E+06
      coef( 25) =   0.2454393399E+04
      coef( 26) =  -0.2437675682E+03
      coef( 27) =   0.1268264265E+04
      coef( 28) =   0.8106444881E+01
      coef( 29) =  -0.3948172732E+03
      coef( 30) =  -0.7109253068E+04
      coef( 31) =  -0.4721259297E+04
      coef( 32) =   0.1828096189E+03
      coef( 33) =   0.6994342008E+06
      coef( 34) =   0.7047813369E+05
c
c nonlinear parameters
c (only those from EQUIVALENCE statements are useful in practice,
c the rest comes from the previous fits, especially to E3)
c
        nparam = 89
        par(1) =   0.367911875040999981
        par(2) =   1.363100526897334
        par(3) =    1.20347408390928079
        par(4) =   0.299999999999999989D-01
        par(5) =    1.00000000000000000
        par(6) =    1.08715694978386201
        par(7) =   -47909236.4512617141
        par(8) =    28607039.7051238120
        par(9) =    12558728.0435810927
        par(10) =    6282255.92169188615
        par(11) =    329466.621355585929
        par(12) =    130639.488489312906
        par(13) =    123.647622808153315
        par(14) =   -151.568453273019315
        par(15) =   -410.581367324416476
        par(16) =   -75.8689917755639271
        par(17) =   0.692599844971184986
        par(18) =   0.692599844971184986
        par(19) =   0.692599844971184986
        par(20) =   0.692599844971184986
        par(21) =   0.692599844971184986
        par(22) =   0.692599844971184986
        par(23) =   0.692599844971184986
        par(24) =   0.692599844971184986
        par(25) =   0.692599844971184986
        par(26) =   0.692599844971184986
        par(27) =   0.488877655105790176
        par(28) =   0.488877655105790176
        par(29) =   0.488877655105790176
        par(30) =   0.488877655105790176
        par(31) =   0.488877655105790176
        par(32) =   0.488877655105790176
        par(33) =   0.488877655105790176
        par(34) =   0.488877655105790176
        par(35) =   0.488877655105790176
        par(36) =   0.488877655105790176
        par(37) =   0.693231401521010926
        par(38) =   0.693231401521010926
        par(39) =   0.693231401521010926
        par(40) =   0.429183032897225480
        par(41) =   0.429183032897225480
        par(42) =   0.429183032897225480
        par(43) =   0.400000000000000022
        par(44) =   1.0
        par(45) =   0.5320145750401045
        par(46) =   0.5348301577779029
        par(47) =      0.65092130545358325
        par(48) =   0.5399632042720384
        par(49) =   0.6323751501902090
        par(50) =   0.8367266956875774
        par(51) =   0.4697434626634999
        par(52) =   0.5378862446558590
        par(53) =   0.5638094016178646
        par(54) =   0.7004124795305201
        par(55) =   0.5
        par(56) =   0.5
        par(57) =   0.5
        par(58) =   0.5
        par(59) =   0.5
        par(60) = 0.6015644842473061
        par(61) =    0.5069725008303007
        par(62) =    0.6503760229540150
        par(63) =    0.2372228743259293
        par(64) =    0.3755126464566924
        par(65) =     1.185340277313890
        par(66) =    0.6120030618701108
        par(67) =    0.4402782662210329
        par(68) =     1.005859386574157
        par(69) =     1.033384787784707
        par(70) =   0.5
        par(71) =   0.5
        par(72) =   0.5
        par(73) =   0.5
        par(74) =   0.5
        par(75) =    0.9483539554371674
        par(76) =    0.2967142087801768
        par(77) =    0.3527330024260356
        par(78) =    0.3328264588316620
        par(79) =    0.5323212634986974
        par(80) =    1.6080190894694926E-03
        par(81) =    0.8451975708109629
        par(82) =    0.3091685998562147
        par(83) =     1.409723018108988
        par(84) =    0.6194135472580364
        par(85) =   0.5
        par(86) =   0.5
        par(87) =   0.5
        par(88) =   0.5
        par(89) =   0.5
       endif
c
      return
      end
c
c 5s_1 version of the exchange quadrupole S2 model.
c The exchange quadrupole interacts with the 5s_1 charge
c distribution instead of the SAPT-ss charges.....
c A little more time consuming, but should improve
c anisotropy flexibility.
c
      SUBROUTINE E10exS2_5s(site3,energy,AOOex,AHHex,AOHex,betaOO,
     &                        betaHH,betaOH)

      IMPLICIT REAL*8 (A-H,O-Z)
      Dimension O(4,3),H1(4,3),H2(4,3),C2(3),C3(3),site3(4,10,3)
      Dimension S2(3),S3(3),ijk(4)
      dimension B7(4,3),B8(4,3),chrg(3)
      common/dat/ par(100),iopar(100),nparam
      equivalence (par(43),exqpos)
      data ijk /1,2,3,0/
c SAPT-5s_1 charges...
      data chrg /0.258504607653328389d0,0.564050362569283648d0,
     1           -0.693302666395947953d0 /
c
      do i=1,3
      do j=1,3
      O(i,j) = site3(i,1,j)
      H1(i,j)= site3(i,2,j)
      H2(i,j)= site3(i,3,j)
      B7(i,j) = site3(i,7,j)
      B8(i,j) = site3(i,8,j)
      enddo
      enddo
     
C loop over the 3 trimers

      energy  = 0.0d0

      do ii = 1,3
C  Calculate possition of the center of mass  for 2 and 3

       do kkk=1,3
        C2(kkk) = site3(ijk(2),6,kkk)
        C3(kkk) = site3(ijk(3),6,kkk)
       end do

C Calculate the  overlap between 2 and 3

      Rsep = dsqrt((C2(1)-C3(1))**2.0d0+
     &             (C2(2)-C3(2))**2.0d0+
     &             (C2(3)-C3(3))**2.0d0)
       OOsep = dsqrt((O(2,1)-O(3,1))**2.0d0 + 
     &               (O(2,2)-O(3,2))**2.0d0 + 
     &               (O(2,3)-O(3,3))**2.0d0 ) 
       HH1sep= dsqrt((H1(2,1)-H1(3,1))**2.0d0 + 
     &               (H1(2,2)-H1(3,2))**2.0d0 + 
     &               (H1(2,3)-H1(3,3))**2.0d0 ) 
       HH2sep= dsqrt((H1(2,1)-H2(3,1))**2.0d0 + 
     &               (H1(2,2)-H2(3,2))**2.0d0 + 
     &               (H1(2,3)-H2(3,3))**2.0d0 ) 
       HH3sep= dsqrt((H2(2,1)-H1(3,1))**2.0d0 + 
     &               (H2(2,2)-H1(3,2))**2.0d0 + 
     &               (H2(2,3)-H1(3,3))**2.0d0 ) 
       HH4sep= dsqrt((H2(2,1)-H2(3,1))**2.0d0 + 
     &               (H2(2,2)-H2(3,2))**2.0d0 + 
     &               (H2(2,3)-H2(3,3))**2.0d0 ) 
       OH1sep= dsqrt((O(2,1)-H1(3,1))**2.0d0 + 
     &               (O(2,2)-H1(3,2))**2.0d0 + 
     &               (O(2,3)-H1(3,3))**2.0d0 ) 
       OH2sep= dsqrt((O(2,1)-H2(3,1))**2.0d0 + 
     &               (O(2,2)-H2(3,2))**2.0d0 + 
     &               (O(2,3)-H2(3,3))**2.0d0 ) 
       OH3sep= dsqrt((O(3,1)-H1(2,1))**2.0d0 + 
     &               (O(3,2)-H1(2,2))**2.0d0 + 
     &               (O(3,3)-H1(2,3))**2.0d0 ) 
       OH4sep= dsqrt((O(3,1)-H2(2,1))**2.0d0 + 
     &               (O(3,2)-H2(2,2))**2.0d0 + 
     &               (O(3,3)-H2(2,3))**2.0d0 ) 
 
c     q1 = ( Aexch*dexp(-beta*Rsep) ) **2.0d0
      q1 = ( AOOex*dexp(-betaOO*OOsep) ) **2.0d0
      q2 = ( AHHex*dexp(-betaHH*HH1sep) ) **2.0d0
      q3 = ( AHHex*dexp(-betaHH*HH2sep) ) **2.0d0
      q4 = ( AHHex*dexp(-betaHH*HH3sep) ) **2.0d0
      q5 = ( AHHex*dexp(-betaHH*HH4sep) ) **2.0d0
      q6 = ( AOHex*dexp(-betaOH*OH1sep) ) **2.0d0
      q7 = ( AOHex*dexp(-betaOH*OH2sep) ) **2.0d0
      q8 = ( AOHex*dexp(-betaOH*OH3sep) ) **2.0d0
      q9 = ( AOHex*dexp(-betaOH*OH4sep) ) **2.0d0

      qind=q1+q2+q3+q4+q5+q6+q7+q8+q9
c     write(6,*)'q ',ii,qind

C Calculate the position of the new site for 2 and 3.
c Maybe the factor 0.4 could be optimized.....

      rRsep = 1.d0/Rsep
      S2(1)=C2(1) - exqpos*(C3(1)-C2(1))*rRsep     ! -q
      S2(2)=C2(2) - exqpos*(C3(2)-C2(2))*rRsep
      S2(3)=C2(3) - exqpos*(C3(3)-C2(3))*rRsep

      S3(1)=C3(1) + exqpos*(C3(1)-C2(1))*rRsep     ! -q
      S3(2)=C3(2) + exqpos*(C3(2)-C2(2))*rRsep
      S3(3)=C3(3) + exqpos*(C3(3)-C2(3))*rRsep


C Calculate the electric interaction with 1

      dS2O =
     &(S2(1)-O(1,1))**2.d0 +(S2(2)-O(1,2))**2.d0+(S2(3)-O(1,3))**2.d0
      dS2H1=
     &(S2(1)-H1(1,1))**2.d0+(S2(2)-H1(1,2))**2.d0+(S2(3)-H1(1,3))**2.d0
      dS2H2=
     &(S2(1)-H2(1,1))**2.d0+(S2(2)-H2(1,2))**2.d0+(S2(3)-H2(1,3))**2.d0
      dS2B7=
     &(S2(1)-B7(1,1))**2.d0+(S2(2)-B7(1,2))**2.d0+(S2(3)-B7(1,3))**2.d0
      dS2B8=
     &(S2(1)-B8(1,1))**2.d0+(S2(2)-B8(1,2))**2.d0+(S2(3)-B8(1,3))**2.d0
      dC2O =
     &(C2(1)-O(1,1))**2.d0+(C2(2)-O(1,2))**2.d0+(C2(3)-O(1,3))**2.d0
      dC2H1=
     &(C2(1)-H1(1,1))**2.d0+(C2(2)-H1(1,2))**2.d0+(C2(3)-H1(1,3))**2.d0
      dC2H2=
     &(C2(1)-H2(1,1))**2.d0+(C2(2)-H2(1,2))**2.d0+(C2(3)-H2(1,3))**2.d0
      dC2B7=
     &(C2(1)-B7(1,1))**2.d0+(C2(2)-B7(1,2))**2.d0+(C2(3)-B7(1,3))**2.d0
      dC2B8 =
     &(C2(1)-B8(1,1))**2.d0+(C2(2)-B8(1,2))**2.d0+(C2(3)-B8(1,3))**2.d0
c
      dS3O =
     &(S3(1)-O(1,1))**2.d0+(S3(2)-O(1,2))**2.d0+(S3(3)-O(1,3))**2.d0
      dS3H1=
     &(S3(1)-H1(1,1))**2.d0+(S3(2)-H1(1,2))**2.d0+(S3(3)-H1(1,3))**2.d0
      dS3H2=
     &(S3(1)-H2(1,1))**2.d0+(S3(2)-H2(1,2))**2.d0+(S3(3)-H2(1,3))**2.d0
      dS3B7=
     &(S3(1)-B7(1,1))**2.d0+(S3(2)-B7(1,2))**2.d0+(S3(3)-B7(1,3))**2.d0
      dS3B8 =
     &(S3(1)-B8(1,1))**2.d0+(S3(2)-B8(1,2))**2.d0+(S3(3)-B8(1,3))**2.d0
      dC3O =
     &(C3(1)-O(1,1))**2.d0+(C3(2)-O(1,2))**2.d0+(C3(3)-O(1,3))**2.d0
      dC3H1=
     &(C3(1)-H1(1,1))**2.d0+(C3(2)-H1(1,2))**2.d0+(C3(3)-H1(1,3))**2.d0
      dC3H2=
     &(C3(1)-H2(1,1))**2.d0+(C3(2)-H2(1,2))**2.d0+(C3(3)-H2(1,3))**2.d0
      dC3B7=
     &(C3(1)-B7(1,1))**2.d0+(C3(2)-B7(1,2))**2.d0+(C3(3)-B7(1,3))**2.d0
      dC3B8 =
     &(C3(1)-B8(1,1))**2.d0+(C3(2)-B8(1,2))**2.d0+(C3(3)-B8(1,3))**2.d0

      term    = qind*(chrg(1)*(1.d0/dsqrt(dC2O) + 1.d0/dsqrt(dC3O)
     1                        -1.d0/dsqrt(dS2O) - 1.d0/dsqrt(dS3O))
     1              + chrg(2)*(1.d0/dsqrt(dC2H1) + 1.d0/dsqrt(dC2H2)
     1                        +1.d0/dsqrt(dC3H1) + 1.d0/dsqrt(dC3H2)
     1                        -1.d0/dsqrt(dS2H1) - 1.d0/dsqrt(dS2H2)
     1                        -1.d0/dsqrt(dS3H1) - 1.d0/dsqrt(dS3H2))
     1              + chrg(3)*(1.d0/dsqrt(dC2B7) + 1.d0/dsqrt(dC2B8)
     1                        +1.d0/dsqrt(dC3B7) + 1.d0/dsqrt(dC3B8)
     1                        -1.d0/dsqrt(dS2B7) - 1.d0/dsqrt(dS2B8)
     1                        -1.d0/dsqrt(dS3B7) - 1.d0/dsqrt(dS3B8)))
 
      energy = energy + term

      do j=1,3
       do i=3,1,-1
        O(i+1,j) =  O(i,j)
        H1(i+1,j)= H1(i,j)
        H2(i+1,j)= H2(i,j) 
        B7(i+1,j)= B7(i,j)
        B8(i+1,j)= B8(i,j)
       enddo
        O(1,j) =O(4,j)
        H1(1,j)=H1(4,j)
        H2(1,j)=H2(4,j)
        B7(1,j)=B7(4,j)
        B8(1,j)=B8(4,j)
      enddo
      do i=3,1,-1
       ijk(i+1) = ijk(i)
      end do
      ijk(1) = ijk(4)

      ENDDO

C change units

      energy  = energy  * 627.51d0

1100  format(3(F7.3,2x))
1010  format(A24,1x,3(F12.9,3x))
1110  format(7(F8.4,3x))
1120  format(F8.4,3x,3(F9.7,3x))
      END
c
c Simple Legendre polynomials routine....
c
      function pl(x,l)
      implicit real*8 (a-h,o-z)
      dimension xx(10)
c      
      xx(1) = x
      do i=2,l
       xx(i) = xx(i-1)*x
      end do
      if(l.eq.0) pl = 1.d0
      if(l.eq.1) pl = x
      if(l.eq.2) pl = 0.5d0*(3.d0*xx(2)-1.d0)
      if(l.eq.3) pl = 0.5d0*x*(5.d0*xx(2)-3.d0)
      if(l.eq.4) pl = 0.125d0*(35.d0*xx(4)-30.d0*xx(2)+3.d0)
      if(l.eq.5) pl = 0.125d0*x*(63.d0*xx(4)-70.d0*xx(2)+15.d0)
      if(l.eq.6) pl = 0.0625d0*(231.d0*xx(6)-315.d0*xx(4)+
     1                          105.d0*xx(2)-5.d0)
      if(l.eq.7) pl = 0.0625d0*x*(429.d0*xx(6)-693.d0*xx(4)+
     1                            315.d0*xx(2)-35.d0)
      if(l.eq.8) pl = 0.0078125d0*(6435.d0*xx(8)-12012.d0*xx(6)+
     1                             6930.d0*xx(4)
     1                -1260.d0*xx(2)+35.d0)
c
      return
      end
c
c Calculate the values of all basis functions for
c a given triplet of sites...
c
      subroutine fun_bas(rab,rbc,rac,nlb,nbas_b,nbas_e, 
     1           p1,p2,p3,d1,d2,d3,values)
      implicit real*8 (a-h,o-z)
      PARAMETER (Nbmax=15)
      dimension values(1),nlb(6,Nbmax),d1(1),d2(1),d3(1)
      dimension p1(0:3),p2(0:3),p3(0:3)
c
c Compute cosines of the angles between triangle sides...
c
c      c1 = 0.5d0*(rab*rab + rbc*rbc - rac*rac)/(rab*rbc)
c      c2 = 0.5d0*(rab*rab + rac*rac - rbc*rbc)/(rab*rac)
c      c3 = 0.5d0*(rac*rac + rbc*rbc - rab*rab)/(rac*rbc)
c      write(6,*)'Cosines:'
c      write(6,*)c1,p1(1)
c      write(6,*)c2,p2(1)
c      write(6,*)c3,p3(1)
c      do l=0,2
c       p1(l) = pl(c1,l)
c       p2(l) = pl(c2,l)
c       p3(l) = pl(c3,l)
c      end do
c
c Basis functions.....
c
      do i=nbas_b,nbas_e
c       n1 = nlb(1,i)
c       n2 = nlb(2,i)
c       n3 = nlb(3,i)
       l1 = nlb(4,i)
       l2 = nlb(5,i)
       l3 = nlb(6,i)
c       d1 = d(n1,ddd,rab)
c       d2 = d(n2,ddd,rbc)
c       write(6,*)'d1,d2',d1,d2
c       pom = (c1**l1)*(c2**l2)*(c3**l3)
c       values(i) = d1*d2*pom/((rab**n1)*(rbc**n2)*(rac**n3))
c       if(n1.ge.0.and.n2.ge.0.and.n3.ge.0) then
c        pom = pl(c1,l1)*pl(c2,l2)*pl(c3,l3)
c        values(i) = (rab**n1)*(rbc**n2)*(rac**n3)*
c     1             dexp(-d1(i)*rab-d2(i)*rbc-d3(i)*rac)*pom
        values(i) = dexp(-d1(i)*rab-d2(i)*rbc-d3(i)*rac)*
     1 p1(l1)*p2(l2)*p3(l3)
c       else
c        values(i) = (rab**n1)*(rac**n3)*dexp(-d2(i)*rbc)
c        if(n1.ne.0) values(i) = values(i)*d(4,d1(i+2),rab)
c        if(n3.ne.0) values(i) = values(i)*d(4,d3(i+2),rac)
c       endif
      end do
c
      return
      end
c
      subroutine getdsts(coor,dstmat,p)
      implicit real*8 (a-h,o-z)
      dimension coor(4,10,3),dstmat(3,3,3,3)
      dimension p(0:2,3,3,3,3)
c
c Calculate distances...
c
      do i=1,2
      do is=1,3
      do j=i+1,3
      do js=1,3
c
       rab = 0.d0
       do k=1,3
        rab = rab + (coor(i,is,k)-coor(j,js,k))**2.d0
       end do
       rab = dsqrt(rab)
       dstmat(i,is,j,js) = rab
       dstmat(j,js,i,is) = rab
      end do
      end do
      end do
      end do
c
c Calculate Legendre polynomials...
c
      do i=1,3
      do j=1,3     ! loop over sites of mol 1,2, and 3
      do k=1,3
       rab = dstmat(1,i,2,j)
       rbc = dstmat(2,j,3,k)
       rac = dstmat(1,i,3,k)
c Cosines:
      c1 = 0.5d0*(rab*rab + rbc*rbc - rac*rac)/(rab*rbc)
      c2 = 0.5d0*(rab*rab + rac*rac - rbc*rbc)/(rab*rac)
      c3 = 0.5d0*(rac*rac + rbc*rbc - rab*rab)/(rac*rbc)
c Legendre polynomials
      call legpol(c1,p(0,2,i,j,k),2)
      call legpol(c2,p(0,1,i,j,k),2)
      call legpol(c3,p(0,3,i,j,k),2)
c
      end do
      end do
      end do
c
      return
      end
c
      subroutine permut(iper,ia,ib,ic,iap,ibp,icp)
      implicit real*8 (a-h,o-z)
c
c      data is1 /1,3,2,1,2,3/
c      data is2 /2,1,3,3,1,2/   ! make permutations inverse to this
c      data is3 /3,2,1,2,3,1/
c
      if(iper.eq.1) then
       iap = ia
       ibp = ib
       icp = ic
      elseif(iper.eq.3) then
       iap = ic
       ibp = ia
       icp = ib
      elseif(iper.eq.2) then
       iap = ib
       ibp = ic
       icp = ia
      elseif(iper.eq.4) then
       iap = ia
       ibp = ic
       icp = ib
      elseif(iper.eq.5) then
       iap = ib
       ibp = ia
       icp = ic
      elseif(iper.eq.6) then
       iap = ic
       ibp = ib
       icp = ia
      endif
c
      return
      end 
c
c Reccursive Legendre polynomials:
c
      subroutine legpol(x,p,lmax)
      implicit real*8 (a-h,o-z)
      dimension p(0:lmax)
c
c starting value
c
      p(0) = 1.d0
c
c compute P_l along the column with m=0
c
        do l = 0,lmax-1
         if((l-1).lt.0) then
           pp = 0
         else
           pp = p(l-1)
         endif
         p(l+1) = ((2*l+1)*x*p(l)-l*pp)/(l+1)
        end do
       return
       end

c Damped version...
c Calculate the contribution of molecule j to the field on i
c Use the corrected SAPT-5s charges (sapt5s_1). Variable
c separ is ignored (introduced only for compatibility
c with the simulation program).
c
      subroutine field5s_1g_dmp(coor,i,j,separ,e)
      implicit real*8 (a-h,o-z)
      dimension coor(4,10,3),e(3)
      dimension sep1(3),sep2(3),sep3(3),chrg(3)
      dimension sep4(3),sep5(3),veciv(3)
      common/dat/ par(100),iopar(100),nparam
      equivalence (par(1),sigpol),(par(2),damp30),(par(3),aex),
     1            (par(4),gamma),(par(5),r0),(par(6),dampSq)
      data plen /1.1216873242d0 /
c position of the polarizability along the bisector given by sigpol
      data chrg /0.258504607653328389d0,0.564050362569283648d0,
     1           -0.693302666395947953d0 /
c
      sep1l = 0.d0    !  O <- COM
      sep2l = 0.d0    ! H1 <- COM
      sep3l = 0.d0    ! H2 <- COM
      sep4l = 0.d0    ! B7 <- COM
      sep5l = 0.d0    ! B8 <- COM
      do k=1,3
       veci = coor(i,2,k) + coor(i,3,k) - 2.d0*coor(i,1,k)
       veci = coor(i,1,k) + 0.5d0*sigpol*veci/plen
       veciv(k) = veci
c COM version
c       sep1(k) = coor(i,6,k) - coor(j,1,k)
c       sep2(k) = coor(i,6,k) - coor(j,2,k)
c       sep3(k) = coor(i,6,k) - coor(j,3,k)
c       sep4(k) = coor(i,6,k) - coor(j,7,k)
c       sep5(k) = coor(i,6,k) - coor(j,8,k)
c Moving polarizability version
       sep1(k) = veci - coor(j,1,k)
       sep2(k) = veci - coor(j,2,k)
       sep3(k) = veci - coor(j,3,k)
       sep4(k) = veci - coor(j,7,k)
       sep5(k) = veci - coor(j,8,k)
       sep1l = sep1l + sep1(k)*sep1(k)
       sep2l = sep2l + sep2(k)*sep2(k)
       sep3l = sep3l + sep3(k)*sep3(k)
       sep4l = sep4l + sep4(k)*sep4(k)
       sep5l = sep5l + sep5(k)*sep5(k)
      end do
      sep1l = sep1l**(-1.5d0)
      sep2l = sep2l**(-1.5d0)
      sep3l = sep3l**(-1.5d0)
      sep4l = sep4l**(-1.5d0)
      sep5l = sep5l**(-1.5d0)
      do k=1,3
       e(k) = chrg(1)*sep1(k)*sep1l +
     1        chrg(2)*(sep2(k)*sep2l + sep3(k)*sep3l) +
     1        chrg(3)*(sep4(k)*sep4l + sep5(k)*sep5l)
      end do
c Damp with f3(damp30*separation between veci and COM of molecule j)
      do k=1,3
       veciv(k) = veciv(k) - coor(j,6,k)
      end do
c Use general version of scalar product
      sepdmp = dsqrt(scalp(veciv,veciv,3))
      dmpfct=d(3,damp30,sepdmp)
      do k=1,3
       e(k) = dmpfct*e(k)
      end do
c
      return
      end
c
c Calculate the vector V resulting from the action
c of the dipole propagator tensor T_ij on U
c Ri, Rj - position vectors of molecules i and j, respectively
c rij = |Ri - Rj|^(-3)
c
        subroutine TprodA(Ri,Rj,u,rij,v)
        implicit real*8 (a-h,o-z)
        dimension Ri(3),Rj(3),u(3),v(3)
c
        ddd = rij**(0.66666666666666666d0)
        scal = 0.d0
        do i=1,3
         v(i) = Ri(i) - Rj(i)
         scal = scal + v(i)*u(i)
        end do
        do i=1,3
         v(i) = (3.d0*v(i)*scal*ddd - u(i))*rij
        end do
c
        return
        end
c
      function d(n,beta,r)
c
c     calculate the damping factor (small R correct)
c
      implicit real*8 (a-h,o-z)
      br=beta*r
c The following line added by RB, Sept. 18 1997
      if(br.eq.0.d0) then
       d = 0.d0
       return
      endif
      sum=1.0d0
      term=1.0d0
      ncn=n
c      ncn = 2*n+4
      do i=1,ncn
        term=term*br/i
        sum=sum+term
      enddo
      d=1.0d0 - dexp(-br)*sum
c     in case of d --> 0 use
c     d=1.0d0 - dexp(-br)*sum = sum_m=ncn+1^\infty br^m/m!
      if(dabs(d).lt.1.0d-8) then
        d=0.0d0
        do i=ncn+1,1000
          term=term*br/i
          d=d+term
          if(term/d .lt. 1.0d-8) go to 111
        enddo
        write(6,*) 'No convergence in d'
  111 continue
      d=d*dexp(-br)
      endif
c     write(6,'(i4,2f10.5,e20.10)') n,beta,r,d
      return
      end
c
c***********************************************************************
c
c RB. Generate the coordinates of all sites from the coordinates of
c O's and H's only.
c
        subroutine coorgen(N,RX,RY,RZ,sig,sig2,sig3,sig4,sig5)
        implicit real*8 (a-h,o-z)
        dimension RX(N,10), RY(N,10), RZ(N,10)
        data plen / 1.1216873242d0/
C
C  sig   is the usual O-COM seperation
C  sig2  is the O sep along the z coordinate of Bunny 1
C  sig3  is the y coordinate of Bunny 1
C  sig4  is the O sep along the z coordinate of Bunny 2
C  sig5  is the y coordinate of Bunny 2
        sig  = 1.24631924913843d-01
        sig2 = 0.371792435d0
        sig3 = 0.2067213d0
        sig4 = -0.125368076d0
        sig5 = 0.2d0

C   1 - O
C   2 - H1
C   3 - H1
C   4 - Bunny2 1 -- exp-type one
C   5 - Bunny2 2 -- exp-type one
C   6 - com
C   7 - Bunny1 1 -- charged one
C   8 - Bunny1 2 -- charged one
C
        do j=1,N
      RX(j,6)=0.5d0*sig*(RX(j,2)+RX(j,3)-2.0d0*RX(j,1))/plen
     &                 + RX(j,1)
      RY(j,6)=0.5d0*sig*(RY(j,2)+RY(j,3)-2.0d0*RY(j,1))/plen
     &                 + RY(j,1)
      RZ(j,6)=0.5d0*sig*(RZ(j,2)+RZ(j,3)-2.0d0*RZ(j,1))/plen
     &                 + RZ(j,1)
c COM - replace with the position of O for the ice generation..
c      rx(j,6) = rx(j,1)
c      ry(j,6) = ry(j,1)
c      rz(j,6) = rz(j,1)
c Vector perpendicular to the molecular plane...
      xcross=(RY(j,2)-RY(j,1))*(RZ(j,3)-RZ(j,1))
     &      -(RZ(j,2)-RZ(j,1))*(RY(j,3)-RY(j,1))
      ycross=(RZ(j,2)-RZ(j,1))*(RX(j,3)-RX(j,1))
     &      -(RX(j,2)-RX(j,1))*(RZ(j,3)-RZ(j,1))
      zcross=(RX(j,2)-RX(j,1))*(RY(j,3)-RY(j,1))
     &      -(RY(j,2)-RY(j,1))*(RX(j,3)-RX(j,1))
      xnorm=dsqrt(xcross**2.d0+ycross**2.d0+zcross**2.d0)
c Bunny 2
      RX(j,4)=sig4*(RX(j,2)+RX(j,3)-2.0d0*RX(j,1))/
     &   (2.0d0*plen)+RX(j,1)+xcross*sig5/xnorm
      RY(j,4)=sig4*(RY(j,2)+RY(j,3)-2.0d0*RY(j,1))/
     &   (2.0d0*plen)+RY(j,1)+ycross*sig5/xnorm
      RZ(j,4)=sig4*(RZ(j,2)+RZ(j,3)-2.0d0*RZ(j,1))/
     &   (2.0d0*plen)+RZ(j,1)+zcross*sig5/xnorm
      RX(j,5)=sig4*(RX(j,2)+RX(j,3)-2.0d0*RX(j,1))/
     &   (2.0d0*plen)+RX(j,1)-xcross*sig5/xnorm
      RY(j,5)=sig4*(RY(j,2)+RY(j,3)-2.0d0*RY(j,1))/
     &   (2.0d0*plen)+RY(j,1)-ycross*sig5/xnorm
      RZ(j,5)=sig4*(RZ(j,2)+RZ(j,3)-2.0d0*RZ(j,1))/
     &   (2.0d0*plen)+RZ(j,1)-zcross*sig5/xnorm
c Bunny 1
      RX(j,7)=sig2*(RX(j,2)+RX(j,3)-2.0d0*RX(j,1))/
     &   (2.0d0*plen)+RX(j,1)+xcross*sig3/xnorm
      RY(j,7)=sig2*(RY(j,2)+RY(j,3)-2.0d0*RY(j,1))/
     &   (2.0d0*plen)+RY(j,1)+ycross*sig3/xnorm
      RZ(j,7)=sig2*(RZ(j,2)+RZ(j,3)-2.0d0*RZ(j,1))/
     &   (2.0d0*plen)+RZ(j,1)+zcross*sig3/xnorm
      RX(j,8)=sig2*(RX(j,2)+RX(j,3)-2.0d0*RX(j,1))/
     &   (2.0d0*plen)+RX(j,1)-xcross*sig3/xnorm
      RY(j,8)=sig2*(RY(j,2)+RY(j,3)-2.0d0*RY(j,1))/
     &   (2.0d0*plen)+RY(j,1)-ycross*sig3/xnorm
      RZ(j,8)=sig2*(RZ(j,2)+RZ(j,3)-2.0d0*RZ(j,1))/
     &   (2.0d0*plen)+RZ(j,1)-zcross*sig3/xnorm
c
       end do
       return
       end
c
        function scalp(a,b,n)
        implicit real*8 (a-h,o-z)
        dimension a(n),b(n)
        pom = 0.d0
        do i=1,n
         pom = pom + a(i)*b(i)
        end do
        scalp = pom
        return
        end
c
       subroutine matvec(a,v)
       implicit real*8 (a-h,o-z)
       dimension a(3,3),v(3),u(3)
c
       n = 3
       do i=1,n
        u(i) = 0.d0
        do j=1,n
         u(i) = u(i) + a(i,j)*v(j)
        end do
       end do
       do i=1,n
        v(i) = u(i)
       end do
       return
       end
c
        subroutine rotmat(ad,bd,gd,u)
c
c Construct the rotation matrix corresponding to
c the Euler angles ad,bd,gd (in radians).
c
        implicit real*8 (a-h,o-z)
        dimension u(3,3)
        sad = dsin(ad)
        sbd = dsin(bd)
        sgd = dsin(gd)
        cad = dcos(ad)
        cbd = dcos(bd)
        cgd = dcos(gd)
c----- construct the transformation matrix
        u(1,1) = cad*cbd*cgd - sad*sgd
        u(1,2) = -cad*cbd*sgd - sad*cgd
        u(1,3) = cad*sbd
        u(2,1) = sad*cbd*cgd + cad*sgd
        u(2,2) = -sad*cbd*sgd + cad*cgd
        u(2,3) = sad*sbd
        u(3,1) = -sbd*cgd
        u(3,2) = sbd*sgd
        u(3,3) = cbd
        return
        end
c
